#ifndef __MODELDEF_H
#define __MODELDEF_H

#include "config.h"
extern double pos[NN][3];               /* site-position = (x,y,z)      */
extern double edg[3][3];                /* edge vectors default=(0,0,0) */
extern int  iw[Nw][2];                  /* array bonds          */
/* arrays contain indizees to float-parameter para[]    */
extern int wt[Nw];                              /* (Bindungs-) Energien */
extern int wj[Nw],wu[NN],we[NN];        /* nhv faster if wj4=wj/4       */
extern int wf[NN];			/* for an external field        */
extern int nn,nw;                       /* number of spins and bonds < NN,Nw */
extern int nu,nd;                       /* number up-/down-spins        */
#if Nv
extern int iw2[Nv][2];
extern int wu2[Nv];                             /* coulomb  U(i,j)      */
extern int wj2[Nv];                             /* exchange J(i,j)      */
#endif
/* values for wt[],wj[],wu[],we[],wu2,wj2[] */
#define MaxPara 128                             /* max. 8bit=1char      */
extern char numpara;                    /* Number of parameters < 256   */
extern double para[MaxPara];            /* Float-Parameters     */


struct tww {                            /* Parameter des Hamiltonien    */
  int   w[Nw];                          /* Phasen-Winkel (Ranbedingung=TBC) */
  double co[Nw],si[Nw];                 /* cos(para[w]),sin(para[w])    */
  int   ex[Nw];                         /* 1 bound ok, -1 size exchange */
};      

extern struct tww  ww;  

#ifndef IFww
#ifdef CONFIG_TBC			/* see config.h */
#define IFww(x)     x
#else
#define IFww(x)
#endif
#endif

#if (0 IFww(+1)) && !defined(CONFIG_TBC)
#error please use CONFIG_TBC instead of IFww in config.h 
#endif

int initvars();	/* function definition */
int outmodel();

#endif
