#ifndef __SYMMETRY_H
#define __SYMMETRY_H 1

#include "config.h"
/* #include "spins.h" */

/* test and if neccessary create up to num symmetries P */

/* --- ABEL(NOABEL) Nutzung abelscher(nichtabelscher) Symmetriegruppe --- */
#if !defined(CONFIG_NOABEL) && !defined(CONFIG_ABEL)
#define CONFIG_NOABEL 1		/* CONFIG_ABEL or CONFIG_NOABEL */
#endif

/* --- S1SYM - besondere Behandlung der Spin-1 ((n>1)/2) Symmetrie --- */
#if !defined(CONFIG_S1SYM) && !defined(CONFIG_NOS1SYM)
#if NN>8*0			/* nur bei grossen Systemen schneller */
#define CONFIG_S1SYM  1		/* CONFIG_S1SYM or CONFIG_NOS1SYM */
#else
#define CONFIG_NOS1SYM  1	/* CONFIG_S1SYM or CONFIG_NOS1SYM */
#endif
#endif
/*
 *  CONFIG_S1SYM useful for spin-1 systems with a lot of symmetries
 *             - does reduce the time needed for scanning for symmetries
 *             - this option should vanish in later versions (js Okt.98)
 */

#ifndef MaxSym
#define MaxSym   (4100)         /* ggf. aendern, braucht int*(3*NN+5) Memory */
#error MaxSym not defined
#endif

#define Sym 4	/* relikt !??? */
#if defined(HFIELD) || defined(CONFIG_TBC)
#define Sud 0   /* or undef ??? */
#else
#define Sud 1
#endif

#if MaxSym<(Sym+1)
#error MaxSym to small
#endif

#if NN>127
#error char is not enough to count >127 sites NN
#endif
#if Zahl & 4				/* new 1998-166 JS */
// typedef Complex     tphase;		/* exp(I*2*Pi*k/l) */
typedef cplx     tphase;		/* exp(I*2*Pi*k/l) */
#else
typedef signed char tphase;		/* only -1 or +1 possible */
#endif
/*  --- int=4*char usually signed/unsigned? pc-specifisch! 
    --- evl. tsym.w als array[k][l] zum speicher sparen
    --- large struct!!! do not use as local variable! Nov99
 */
struct tsym {				/* Symmetrien	*/
  int	init,numsym,numall,wud;		/*  ini,Sym,1<<Sym,Wud      */
  signed char i[MaxSym][NN];		/*  Permutation j->i[j]	*/
  char	      k[MaxSym];		/*  k => exp(i*2Pi*k)	*/
  tphase      w[MaxSym];		/*  weight exp(i*2Pi*k)=1,-1 l=2 or 0 */
  char	      l[MaxSym];		/*  cycle length k = 0,1,2,..,l-1 */
  char	      g[MaxSym];		/*  1 = generators of sym-group */
  signed char lm[NN];			/* identical sites get same idx */
  signed char li[NN];			/* index in lm-group */
  char  num_lm;				/*  number of spins (diff. idx) */
  int   korr[NN][NN];			/* array of sym. pairkorrelations */
  signed char dkorr[NN*NN][2];		/* different pair-korrelations */
  int   num_dkorr;			/* number of -//- (0..NN*(NN-1)) */
  int   subl;				/* sublattice number */
  int   sl[NN];				/* sublattice index */
  int   inverse[MaxSym];		/* point to P^(-1) */
  int   kgen[MaxSym];			/* Vorgaben k fuer Generatoren */
};

extern struct tsym sym;

int symcreate(int maxsym);
int test_all_sym();

#endif
