#ifndef __XVAL_H
#define __XVAL_H 1
/* Expectationvalues etc. of EF */

#include "defs.h"

#define MAXx 200l	/* max. Anzahl auszugebener Koeffizienten */

extern ULong	x_max;		/* max. anzahl koeff. 0..MAXx	*/

/* -------------------------------------------------------------------- */
/* --------       Analyse des Eigenvectors                  ----------- */
/* -------------------------------------------------------------------- */
/* Koeff. x_i sortieren, groesster x_i => r[MAXx-1]
// mode=0 maximum values
// mode=1 minimum values
*/
int x_out(FILE *f,tvec *v0,int mode);

/* ---- Anzahl verschiedener Koeffizienten bestimmen  --------- */
int x_sort(FILE *f,tvec *v0,tvec *v1);

cplx wh(tvec *v0);			/* Erwartungswert <H> */

double whq(tvec *v0,cplx rh);  /* Fehler Erwartungswert (H*v-h*v)/h */

/* mittelwert <v1|T*v0>/<v0|v0> (v1=v0) und abweichung (T|v0>-<T>v0)^2 
 *   |k> = q sum_R^l exp(i*k*R) T_R |v>   ( Tx_R |x> = |x+R> ) 
 *       = q sum_m^l exp(i*k*m) T^m |v>   - Fouriertransformation k=2*Pi/l*k
 *   rk  = <v|k>			  q=1/sqrt(sum_m^l exp(i*k*m)^2)=2/l
 */ 
cplx wop_k(tvec *v0,tvec *v1,int ip);
    
cplx wop_t(tvec *v0,tvec *v1,int ip);
 
cplx wop_ud(tvec *v0,tvec *v1); /* v1=T*v0  u<->d */

zahl wss(tvec *v0,tvec *v1); /* SS=1/2*(SpSm+SmSp)+S0^2 ss=s(s+1) */

cplx wjj(tvec *v0,tvec *v1); /* Hubbard SuperSpin Lit.? */

cplx wnn(int i1,int i2,tvec *v0,tvec *v1);

cplx wns(int i1,tvec *v0,tvec *v1,int s); /* v1=nis*v0 s:1=u,2=d, 3=ud */

/* Rueckgabe: 1-Marshallgewicht (Gewicht der verletzenden Zustaende) */
cplx mrule(tvec *v0, int *sl, int num_sl);

cplx wsisj(int iw1,int iw2,tvec *v0,tvec *v1);/* <v1|SiSj|v0> */

cplx wzizj(int iw1,int iw2,tvec *v0,tvec *v1); /* <v1|SiSj|v0> */

cplx wzi(int iw1,tvec *v0); /* <v0|Szi|v0> */

/* evl. zi()-fkt fuer spin1 in modeldef.h definieren! (allgemeiner) */
/* only for dimer model, spin 1 chains , spin-1 = 2 Spin-1/2 = (4n+2)+(4n+3)
   O(z,pi,i,j)=<v1|Szi*exp(sum(i*Pi*Szk,k=i+1..j))*Szj|v0> |Si|=1*/
int stringorder(FILE *f1,tvec *v0);

/* only for spin 1 chains , spin-1 = 2 Spin-1/2 = (4n+2)+(4n+3)
   O(z,pi,i,j)=<v1|Szi*exp(sum(i*Pi*Szk,k=i+1..j))*Szj|v0> |Si|=1*/
int stringorder2(FILE *f1,tvec *v0);

/* Z=<> */
#ifdef SBase
cplx wzijk(int iw1, ...);
#else
cplx wzijk(int iw1,int iw2,int iw3,tvec *v0,tvec *v1);
#endif

#if defined(N1) && defined(N2) && N1>1 
cplx wdx(tvec *v0);
cplx wdy(tvec *v0);
cplx wc(tvec *v0);
cplx wz(tvec *v0);
int  wtatb(cplx *rta, cplx *rtb, tvec *v0);
#endif	/* N1>1 */

#endif
